layui.extend({
    common    :   'js/common',
    xmSelect    :   'layui/dist/xm-select',
}).use(['tree','table', 'jquery','layer','common','form','xmSelect'], function () {
    //  弹窗插件
    var layer = layui.layer;
    //  Jquery插件
    var $ = layui.jquery;
    //  引入公共模块
    var common = layui.common;
    //  引入表格
    var table = layui.table;
    //  引入表单
    var form = layui.form;
    //  引入下拉菜单
    var xmSelect = layui.xmSelect;

    var layuiTable = null;

    // 查询框表单
    var $node = {
        //  单元搜索
        unitId  :  $('#unit_id'),
        //  房间名称
        nameInput  :  $('input[name="name"]'),
        //  房间编号
        houseNumberInput  :  $('input[name="houseNumber"]'),
    };

    //  页面数据
    var pageData = {
        myOrgId     :   parseInt($('#org_id').val()),
        residentialId: $('#residentialId').val()
    };

    //选中id集合
    var ids = [];
    //清空选中集合
    var clearCheckbox = function(){
        ids=[];
    };
    //tableId集合
    var table_data = [];

    //  重新加载表格
    var reloadTable = function(obj){
        //重新加载表格
        layuiTable.reload({
            where:{
                name  :  $node.nameInput.val(),
                houseNumber  :  $node.houseNumberInput.val(),
                unitId  :  $node.unitId.val(),
                //排序
                sortField   :   obj?obj.field:'',
                sortOrder   :   obj?obj.type:'',
            }
            //重新从第1页开始
            ,page: {
                curr: 1
            }
        });
    };

    //  初始化
    (function(){
        //  初始化表格
        layuiTable = common.layuiTable.render(layui.table,{
            elem: '#table_id'
            , url: '/estate/room/showRoomList?residentialId=' + pageData.residentialId
            , method: 'GET'//  接口http请求类型，默认：get
            , cellMinWidth: 80//全局定义常规单元格的最小宽度，
            , cols: [[
                {type: 'checkbox'}
                , {field: 'name', title: '房间名称',width: 200, align: 'center'}
                , {field: 'houseNumber', title: '门牌号', align: 'center',sort:true}
                , {field: 'unitName', title: '所属单元', align: 'center'}
                , {field: 'residentialName', title: '所属小区', align: 'center'}
                , {field: 'userNumber', title: '住户总数', align: 'center'}
                , {field: 'serial', title: '排序', sort: true, edit: 'text', align: 'center'}
                , {title: '操作', width: 180, align: 'center', toolbar: '#table-useradmin-webuser'}
            ]]
            //  开启分页功能
            , page: true
            // ,height: 'full-145'
            ,done:function(res,curr,count){
                // 设置换页勾选之前的
                table_data = res.data;
                for(var i=0;i<res.data.length;i++){
                    for(var j=0;j<ids.length;j++){
                        if(res.data[i].id==ids[j]){
                            //这里才是真正的有效勾选
                            res.data[i]["LAY_CHECKED"]='true';
                            //找到对应数据改变勾选样式，呈现出选中效果
                            var index= res.data[i]['LAY_TABLE_INDEX'];
                            $('.layui-table tr[data-index=' + index + '] input[type="checkbox"]').prop('checked', true);
                            $('.layui-table tr[data-index=' + index + '] input[type="checkbox"]').next().addClass('layui-form-checked');
                        }
                    }
                }
                //设置全选checkbox的选中状态，只有改变LAY_CHECKED的值， table.checkStatus才能抓取到选中的状态
                var checkStatus = table.checkStatus('table_id');
                if(checkStatus.isAll){
                    $(' .layui-table-header th[data-field="0"] input[type="checkbox"]').prop('checked', true);
                    $('.layui-table-header th[data-field="0"] input[type="checkbox"]').next().addClass('layui-form-checked');
                }
            }
        });
    })();

    //排序
    layui.table.on('sort(table_event)',function (obj) {
        reloadTable(obj);
    });

    //监听单元格编辑
    table.on('edit(table_event)', function(obj){
        var data = {
            id : obj.data.id,
            serial : obj.value
        };
        if (data.serial != null && data.serial != ''){
            var pass = true;
            var message = '';
            if (data.serial[0] == 0){
                pass = false;
                message = '【失败，请输入不以0开头的数字】';
            }
            if(!/(^$)|^\d+$/.test(data.serial)){
                pass = false;
                message = '【失败，只能填写数字】';
            }
            if (pass){
                common.sendAsyncRequest('/estate/room/updateRoom','POST',data,function (result) {
                    message = result.data?'【成功】':'【失败，请重新修改】';
                });
            }else {
                $(this).val($(this).prev().text());
            }
            layer.msg('修改【'+ obj.data.name +'】房间的序号为['+ data.serial + ']</br>' + message);
        }else {
            $(this).val($(this).prev().text());
        }
    });

    //复选框选中监听,将选中的id 设置到缓存数组,或者删除缓存数组
    table.on('checkbox(table_event)', function (obj) {
        if(obj.checked==true){
            if(obj.type=='one'){
                ids.push(obj.data.id)
            }else{
                for(var i=0;i<table_data.length;i++){
                    ids.push(table_data[i].id);
                }
            }
        }else{
            if(obj.type=='one'){
                for(var i=0;i<ids.length;i++){
                    if(ids[i]==obj.data.id){
                        ids.splice(i,1);
                        return;
                    }
                }
            }else{
                for(var i=0;i<ids.length;i++){
                     for(var j=0;j<table_data.length;j++){
                        if(ids[i]==table_data[j].id){
                            ids.splice(i,1);
                            i--;
                            break;
                        }
                    }
                }
            }
        }
    });

    //监听行工具事件
    table.on('tool(table_event)', function(obj){ //注：lay-filter="table-event""
        var data = obj.data; //获得当前行数据
        switch (obj.event) {
            case 'edit'://修改
                common.openDefaultIframe({
                    title: '修改房间',
                    content:  '/estate/room/edit/'+data.id
                });
                break;
            case 'del'://删除
                layer.confirm('是否确认删除？',{icon: 7, title:'提示'}, function(index){
                    common.sendAsyncRequest("/estate/room/deleteRoom",'POST',{
                        id  :  data.id
                    },function (result){
                        if(result.data){
                            //  刷新表格
                            layuiTable.reload();
                            layer.msg("删除成功");
                            layer.close(index);
                        }else{
                            layer.msg("删除失败");
                        }
                    });
                });
                break;
            case 'detail'://管理
                common.openDefaultIframe({
                    title : '管理房间——' + data.name,
                    content :  '/estate/room/detail/' +data.id
                });
                break;
            default:
                break;
        };
    });

    //监听搜索
    form.on('submit(query)', function(){
        reloadTable();
    });

    //监听重置查询
    form.on('submit(reset)', function(){
        $node.nameInput.val('');
        $node.houseNumberInput.val('');
        unitSelect.setValue([])
        $node.unitId.val('');
        form.render('select');
        reloadTable();
    });

    //监听房间添加
    form.on('submit(add)', function(){
        common.openDefaultIframe({
            title: '添加房间',
            content:'/estate/room/add/'+pageData.residentialId+'/2'
        });
    });

    //监听批量删除
    form.on('submit(batchdel)', function(){
        if(ids.length == 0 ){
            layer.msg("请选择要删除的数据。");
            return;
        }
        layer.confirm('是否确认删除？',{icon: 7, title:'提示'}, function(index){
            console.log(ids);
            $.ajax({
                url :   '/estate/room/deleteRoomList',
                type : 'POST',
                contentType: "application/json;charset=utf-8",
                data :JSON.stringify(ids),
                success :  function(result){
                    if(result.code == '200'){
                        if(result.data){
                            //  刷新表格
                            layuiTable.reload();
                            clearCheckbox();
                            layer.msg("删除成功");
                            layer.close(index);
                        }else{
                            layer.msg("删除失败");
                        }
                    }else{
                        layer.msg(result.msg);
                    }
                }
            });
        });
    });

    //单元查询下拉列表
    var unitSelect = xmSelect.render({
        el: '#unit_name',
        radio: true,
        prop: {
            name: 'name',
            value: 'id',
        },
        toolbar: {
            show: true,
            list: [{
                name: '清空',
                method: function(){
                    unitSelect.setValue([]);
                    $node.unitId.val('');
                }
            }]
        },
        clickClose: true,
        paging: true,
        pageRemote: true,
        filterable: true,
        remoteMethod: function (val, cb, show,pageIndex) {
            $.ajax({
                type: 'GET',
                url: '/estate/unit/showUnitList',
                data: {
                    name : val,
                    residentialId : pageData.residentialId,
                    current : pageIndex,
                },
                success: function (result) {
                    cb(result.data.records,5);
                },
                error: function () {
                    cb([],0);
                }
            });
        },
        //监听选择
        on: function (data) {
            var change = data.change;
            if (change.length > 0) {
                $node.unitId.val(change[0].id)
            }
            if (!data.isAdd) {
                $node.unitId.val('');
            }
        },
        //显示方式
        model: {
            label: {
                type: 'text',
                text: {
                    //左边拼接的字符
                    left: '',
                    //右边拼接的字符
                    right: '',
                    //中间的分隔符
                    separator: ', ',
                },
            }
        },
    });
});